using MemoryPack;

namespace Insight.Agent.Messages
{
    [MemoryPackUnion(20, typeof(Mainboard))]
    public partial interface IAgentMessage { }

    [MemoryPackable]
    public partial class Mainboard : IAgentMessage
    {
        [MemoryPackOrder(0)]
        public string? Manufacturer { get; set; }

        [MemoryPackOrder(1)]
        public string? Model { get; set; }

        [MemoryPackOrder(2)]
        public string? Serial { get; set; }

        [MemoryPackOrder(3)]
        public string? BiosManufacturer { get; set; }

        [MemoryPackOrder(4)]
        public string? BiosVersion { get; set; }

        [MemoryPackOrder(5)]
        public DateTime? BiosDate { get; set; }
    }
}